- Aldebaran documentation |
- C++ Libraries |
- index

alrobotmodel 2.8.7.4

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Pages
Public Member Functions | Public Attributes | List of all members
Sim::Model Class Reference

Model is responsible of giving information of a physical robot. More...

`#include <alrobotmodel.h>`

## Public Member Functions
| Model (const std::string &pathToModel)
| creates a Model with the file given. Throws if a problem occurs while parsing the file. More...
| ~Model ()
| destructor. More...
const std::string & | name () const
| gives the robot name. Use this to identify the type of the robot More...
std::string | prettyName (int verbosity=0) const
| gives the displayable, beautiful robot name. More...
const std::string & | configFile () const
| returns the content of the file used to create the model. More...
std::vector< const Joint * > | joints () const
| returns a vector containing pointers to all joints of the current model. More...
const Joint * | joint (const std::string &jointName) const
| returns the joint named jointName, or a NULL pointer if the named joint has not been found. More...
std::vector< const JointSymmetry * > | jointSymmetries () const
| returns a vector containing pointers to all joint symmetries of current model. More...
const JointSymmetry * | jointSymmetry (const std::string &jointName) const
| returns the JointSymmetry involving the given Joint, or NULL pointer if the given Joint has not been found. More...
std::vector< const JointGroup * > | jointGroups () const
| returns a vector containing pointers to all predefined joint groups in the current model. More...
const JointGroup * | jointGroup (const std::string &jointGroupName) const
| returns the JointGroup named jointGroupName, or a NULL pointer if it has not been found. More...
std::vector< const JointGroup * > | jointGroupsOfJoint (const std::string &jointName) const
| returns a vector containing pointers to all predefined joint groups containing the joint named jointName. More...
std::vector< const Link * > | links () const
| returns a vector containing pointers to all links of the current model. More...
const Link * | link (const std::string &linkName) const
| returns the link named linkName, or a NULL pointer if the named link has not been found. More...
const Link * | rootLink () const
| returns a pointer to the root link of the model, the base link of the Model. More...
std::vector< const Actuator * > | actuators () const
| returns a vector containing pointers to all actuators of the current model. More...
const Actuator * | actuator (const std::string &actuatorName) const
| returns the actuator named actuatorName, or a NULL pointer if the named actuator has not been found. More...
std::vector< const ActuatorGroup * > | actuatorGroups () const
| returns a vector containing pointers to all predefined actuator groups in the current model. More...
const ActuatorGroup * | actuatorGroup (const std::string &actuatorGroupName) const
| returns the ActuatorGroup named actuatorGroupName, or a NULL pointer if it has not been found. More...
std::vector< const ActuatorGroup * > | actuatorGroupsOfJoint (const std::string &jointName) const
| returns a vector containing pointers to all predefined actuator groups containing the joint named jointName. More...
std::vector< const AngleActuator * > | angleActuators () const
| returns a vector containing pointers to all angle actuators of the current model. More...
const AngleActuator * | angleActuator (const std::string &actuatorName) const
| returns the angle actuator named actuatorName, or a NULL pointer if the named angle actuator has not been found. More...
std::vector< const CoupledActuator * > | coupledActuators () const
| returns a vector containing pointers to all coupled actuators of the current model. More...
const CoupledActuator * | coupledActuator (const std::string &actuatorName) const
| returns the coupled actuator named actuatorName, or a NULL pointer if the named coupled actuator has not been found. More...
std::vector< const TorqueActuator * > | torqueActuators () const
| returns a vector containing pointers to all torque actuators of the current model. More...
const TorqueActuator * | torqueActuator (const std::string &actuatorName) const
| returns the torque actuator named actuatorName, or a NULL pointer if the named torque actuator has not been found. More...
std::vector< const AngleSpeedActuator * > | angleSpeedActuators () const
| returns a vector containing pointers to all angle speed actuators of the current model. More...
const AngleSpeedActuator * | angleSpeedActuator (const std::string &actuatorName) const
| returns the angle speed actuator named actuatorName, or a NULL pointer if the named angle speed actuator has not been found. More...
std::vector< const WheelTorqueActuator * > | wheelTorqueActuators () const
| returns a vector containing pointers to all wheel torque actuators of the current model. More...
const WheelTorqueActuator * | wheelTorqueActuator (const std::string &actuatorName) const
| returns the wheel torque actuator named actuatorName, or a NULL pointer if the named wheel torque actuator has not been found. More...
std::vector< const WheelVelocityActuator * > | wheelVelocityActuators () const
| returns a vector containing pointers to all wheel velocity actuators of the current model. More...
const WheelVelocityActuator * | wheelVelocityActuator (const std::string &actuatorName) const
| returns the wheel velocity actuator named actuatorName, or a NULL pointer if the named wheel velocity actuator has not been found. More...
std::vector< const LEDActuator * > | ledActuators (const std::string &groupName=std::string()) const
| returns a vector containing pointers to all LED actuators of the current model if groupName is empty, and to the LED actuators belonging to the group groupName otherwise More...
const LEDActuator * | ledActuator (const std::string &actuatorName) const
| returns the LE actuator named actuatorName, or a NULL pointer if the named LED actuator has not been found. More...
std::vector< const Sensor * > | sensors () const
| returns a vector containing pointers to all sensors of the current model. More...
const Sensor * | sensor (const std::string &sensorName) const
| returns the sensor named sensorName, or a NULL pointer if the named sensor has not been found. More...
std::vector< const AngleSensor * > | angleSensors () const
| returns a vector containing pointers to all angle sensors of the current model. More...
const AngleSensor * | angleSensor (const std::string &sensorName) const
| returns the angle sensor named sensorName, or a NULL pointer if the named angle sensor has not been found. More...
std::vector< const CoupledSensor * > | coupledSensors () const
| returns a vector containing pointers to all coupled sensors of the current model. More...
const CoupledSensor * | coupledSensor (const std::string &sensorName) const
| returns the coupled sensor named sensorName, or a NULL pointer if the named coupled sensor has not been found. More...
std::vector< const TorqueSensor * > | torqueSensors () const
| returns a vector containing pointers to all torque sensors of the current model. More...
const TorqueSensor * | torqueSensor (const std::string &sensorName) const
| returns the torque sensor named sensorName, or a NULL pointer if the named torque sensor has not been found. More...
std::vector< const AngleSpeedSensor * > | angleSpeedSensors () const
| returns a vector containing pointers to all angle speed sensors of the current model. More...
const AngleSpeedSensor * | angleSpeedSensor (const std::string &sensorName) const
| returns the angle speed sensor named sensorName, or a NULL pointer if the named angle speed sensor has not been found. More...
std::vector< const WheelVelocitySensor * > | wheelVelocitySensors () const
| returns a vector containing pointers to all wheel velocity sensors of the current model. More...
const WheelVelocitySensor * | wheelVelocitySensor (const std::string &sensorName) const
| returns the wheel velocity sensor named sensorName, or a NULL pointer if the named wheel velocity sensor has not been found. More...
std::vector< const CameraSensor * > | cameraSensors () const
| returns a vector containing pointers to all camera sensors of the current model. More...
const CameraSensor * | cameraSensor (const std::string &sensorName) const
| returns the camera sensor named sensorName, or a NULL pointer if the named camera sensor has not been found. More...
std::vector< const CameraStereoSensor * > | cameraStereoSensors () const
| returns a vector containing pointers to all camera stereo sensors of the current model. More...
const CameraStereoSensor * | cameraStereoSensor (const std::string &sensorName) const
| returns the camera stereo sensor named sensorName, or a NULL pointer if the named camera stereo sensor has not been found. More...
std::vector< const CameraDepthSensor * > | cameraDepthSensors () const
| returns a vector containing pointers to all camera depth sensors of the current model. More...
const CameraDepthSensor * | cameraDepthSensor (const std::string &sensorName) const
| returns the camera depth sensor named sensorName, or a NULL pointer if the named camera depth sensor has not been found. More...
std::vector< const FSRSensor * > | fsrSensors () const
| returns a vector containing pointers to all FSR sensors of the current model. More...
const FSRSensor * | fsrSensor (const std::string &sensorName) const
| returns the FSR sensor named sensorName, or a NULL pointer if the named FSR sensor has not been found. More...
std::vector< const InertialSensor * > | inertialSensors () const
| returns a vector containing pointers to all inertial sensors of the current model. More...
const InertialSensor * | inertialSensor (const std::string &sensorName) const
| returns the inertial sensor named sensorName, or a NULL pointer if the named inertial sensor has not been found. More...
std::vector< const SonarSensor * > | sonarSensors () const
| returns a vector containing pointers to all sonar sensors of the current model. More...
const SonarSensor * | sonarSensor (const std::string &sensorName) const
| returns the sonar sensor named sensorName, or a NULL pointer if the named sonar sensor has not been found. More...
std::vector< const BumperSensor * > | bumperSensors () const
| returns a vector containing pointers to all bumper sensors of the current model. More...
const BumperSensor * | bumperSensor (const std::string &sensorName) const
| returns the bumper sensor named sensorName, or a NULL pointer if the named bumper sensor has not been found. More...
std::vector< const TactileSensor * > | tactileSensors () const
| returns a vector containing pointers to all tactile sensors of the current model. More...
const TactileSensor * | tactileSensor (const std::string &sensorName) const
| returns the tactile sensor named sensorName, or a NULL pointer if the named tactile sensor has not been found. More...
std::vector< const SingleDepthSensor * > | singleDepthSensors () const
| returns a vector containing pointers to all the single depth sensors of the current model. More...
const SingleDepthSensor * | singleDepthSensor (const std::string &sensorName) const
| returns the single depth sensor named sensorName, or a NULL pointer if the named single depth sensor has not been found. More...
std::vector< const ArrayDepthSensor * > | arrayDepthSensors () const
| returns a vector containing pointers to all the array depth sensors of the current model. More...
const ArrayDepthSensor * | arrayDepthSensor (const std::string &sensorName) const
| returns the array depth sensor named sensorName, or a NULL pointer if the named array depth sensor has not been found. More...
std::vector< const DepthInfraredSensor * > | depthInfraredSensors () const
| returns a vector containing pointers to all depth infrared sensors of the current model. More...
const DepthInfraredSensor * | depthInfraredSensor (const std::string &sensorName) const
| returns the single depth sensor named sensorName, or a NULL pointer if single named depth infrared sensor has not been found. More...
std::vector< const MicrophoneSensor * > | microphoneSensors () const
| returns a vector containing pointers to all the microphone sensors of the current model. More...
const MicrophoneSensor * | microphoneSensor (const std::string &sensorName) const
| returns the microphone sensor named sensorName, or a NULL pointer if the named microphone sensor has not been found. More...

## Public Attributes
class ModelImpl * | a_impl
| private implementation. More...

## Detailed Description

Model is responsible of giving information of a physical robot.

Definition at line 60 of file alrobotmodel.h.

## Constructor & Destructor Documentation

Sim::Model::Model | ( | const std::string & | pathToModel | ) |

creates a Model with the file given. Throws if a problem occurs while parsing the file.

Remarks
  This lib comes with a set of xml files describing robots. The file given should be the path to one of those!

Sim::Model::~Model | ( |  | ) |

destructor.

## Member Function Documentation

const Actuator* Sim::Model::actuator | ( | const std::string & | actuatorName | ) | const

returns the actuator named actuatorName, or a NULL pointer if the named actuator has not been found.

const ActuatorGroup* Sim::Model::actuatorGroup | ( | const std::string & | actuatorGroupName | ) | const

returns the ActuatorGroup named actuatorGroupName, or a NULL pointer if it has not been found.

std::vector<const ActuatorGroup*> Sim::Model::actuatorGroups | ( |  | ) | const

returns a vector containing pointers to all predefined actuator groups in the current model.

std::vector<const ActuatorGroup*> Sim::Model::actuatorGroupsOfJoint | ( | const std::string & | jointName | ) | const

returns a vector containing pointers to all predefined actuator groups containing the joint named jointName.

Remarks
  the returned vector will be empty if the Joint is not attached to an Actuator belonging to an ActuatorGroup or if the Joint does not exist.

std::vector<const Actuator*> Sim::Model::actuators | ( |  | ) | const

returns a vector containing pointers to all actuators of the current model.

const AngleActuator* Sim::Model::angleActuator | ( | const std::string & | actuatorName | ) | const

returns the angle actuator named actuatorName, or a NULL pointer if the named angle actuator has not been found.

std::vector<const AngleActuator*> Sim::Model::angleActuators | ( |  | ) | const

returns a vector containing pointers to all angle actuators of the current model.

const AngleSensor* Sim::Model::angleSensor | ( | const std::string & | sensorName | ) | const

returns the angle sensor named sensorName, or a NULL pointer if the named angle sensor has not been found.

std::vector<const AngleSensor*> Sim::Model::angleSensors | ( |  | ) | const

returns a vector containing pointers to all angle sensors of the current model.

const AngleSpeedActuator* Sim::Model::angleSpeedActuator | ( | const std::string & | actuatorName | ) | const

returns the angle speed actuator named actuatorName, or a NULL pointer if the named angle speed actuator has not been found.

std::vector<const AngleSpeedActuator*> Sim::Model::angleSpeedActuators | ( |  | ) | const

returns a vector containing pointers to all angle speed actuators of the current model.

const AngleSpeedSensor* Sim::Model::angleSpeedSensor | ( | const std::string & | sensorName | ) | const

returns the angle speed sensor named sensorName, or a NULL pointer if the named angle speed sensor has not been found.

std::vector<const AngleSpeedSensor*> Sim::Model::angleSpeedSensors | ( |  | ) | const

returns a vector containing pointers to all angle speed sensors of the current model.

const ArrayDepthSensor* Sim::Model::arrayDepthSensor | ( | const std::string & | sensorName | ) | const

returns the array depth sensor named sensorName, or a NULL pointer if the named array depth sensor has not been found.

std::vector<const ArrayDepthSensor*> Sim::Model::arrayDepthSensors | ( |  | ) | const

returns a vector containing pointers to all the array depth sensors of the current model.

const BumperSensor* Sim::Model::bumperSensor | ( | const std::string & | sensorName | ) | const

returns the bumper sensor named sensorName, or a NULL pointer if the named bumper sensor has not been found.

std::vector<const BumperSensor*> Sim::Model::bumperSensors | ( |  | ) | const

returns a vector containing pointers to all bumper sensors of the current model.

const CameraDepthSensor* Sim::Model::cameraDepthSensor | ( | const std::string & | sensorName | ) | const

returns the camera depth sensor named sensorName, or a NULL pointer if the named camera depth sensor has not been found.

std::vector<const CameraDepthSensor*> Sim::Model::cameraDepthSensors | ( |  | ) | const

returns a vector containing pointers to all camera depth sensors of the current model.

const CameraSensor* Sim::Model::cameraSensor | ( | const std::string & | sensorName | ) | const

returns the camera sensor named sensorName, or a NULL pointer if the named camera sensor has not been found.

std::vector<const CameraSensor*> Sim::Model::cameraSensors | ( |  | ) | const

returns a vector containing pointers to all camera sensors of the current model.

const CameraStereoSensor* Sim::Model::cameraStereoSensor | ( | const std::string & | sensorName | ) | const

returns the camera stereo sensor named sensorName, or a NULL pointer if the named camera stereo sensor has not been found.

std::vector<const CameraStereoSensor*> Sim::Model::cameraStereoSensors | ( |  | ) | const

returns a vector containing pointers to all camera stereo sensors of the current model.

const std::string& Sim::Model::configFile | ( |  | ) | const

returns the content of the file used to create the model.

Remarks
  The file returned is an xml defining the model.

const CoupledActuator* Sim::Model::coupledActuator | ( | const std::string & | actuatorName | ) | const

returns the coupled actuator named actuatorName, or a NULL pointer if the named coupled actuator has not been found.

std::vector<const CoupledActuator*> Sim::Model::coupledActuators | ( |  | ) | const

returns a vector containing pointers to all coupled actuators of the current model.

const CoupledSensor* Sim::Model::coupledSensor | ( | const std::string & | sensorName | ) | const

returns the coupled sensor named sensorName, or a NULL pointer if the named coupled sensor has not been found.

std::vector<const CoupledSensor*> Sim::Model::coupledSensors | ( |  | ) | const

returns a vector containing pointers to all coupled sensors of the current model.

const DepthInfraredSensor* Sim::Model::depthInfraredSensor | ( | const std::string & | sensorName | ) | const

returns the single depth sensor named sensorName, or a NULL pointer if single named depth infrared sensor has not been found.

Deprecated:
  use singleDepthSensor instead.

std::vector<const DepthInfraredSensor*> Sim::Model::depthInfraredSensors | ( |  | ) | const

returns a vector containing pointers to all depth infrared sensors of the current model.

Deprecated:
  use singleDepthSensors instead.

const FSRSensor* Sim::Model::fsrSensor | ( | const std::string & | sensorName | ) | const

returns the FSR sensor named sensorName, or a NULL pointer if the named FSR sensor has not been found.

std::vector<const FSRSensor*> Sim::Model::fsrSensors | ( |  | ) | const

returns a vector containing pointers to all FSR sensors of the current model.

const InertialSensor* Sim::Model::inertialSensor | ( | const std::string & | sensorName | ) | const

returns the inertial sensor named sensorName, or a NULL pointer if the named inertial sensor has not been found.

std::vector<const InertialSensor*> Sim::Model::inertialSensors | ( |  | ) | const

returns a vector containing pointers to all inertial sensors of the current model.

const Joint* Sim::Model::joint | ( | const std::string & | jointName | ) | const

returns the joint named jointName, or a NULL pointer if the named joint has not been found.

const JointGroup* Sim::Model::jointGroup | ( | const std::string & | jointGroupName | ) | const

returns the JointGroup named jointGroupName, or a NULL pointer if it has not been found.

std::vector<const JointGroup*> Sim::Model::jointGroups | ( |  | ) | const

returns a vector containing pointers to all predefined joint groups in the current model.

std::vector<const JointGroup*> Sim::Model::jointGroupsOfJoint | ( | const std::string & | jointName | ) | const

returns a vector containing pointers to all predefined joint groups containing the joint named jointName.

Remarks
  the returned vector will be empty if the Joint does not belong to a JointGroup, or if the Joint does not exist.

std::vector<const Joint*> Sim::Model::joints | ( |  | ) | const

returns a vector containing pointers to all joints of the current model.

std::vector<const JointSymmetry*> Sim::Model::jointSymmetries | ( |  | ) | const

returns a vector containing pointers to all joint symmetries of current model.

const JointSymmetry* Sim::Model::jointSymmetry | ( | const std::string & | jointName | ) | const

returns the JointSymmetry involving the given Joint, or NULL pointer if the given Joint has not been found.

const LEDActuator* Sim::Model::ledActuator | ( | const std::string & | actuatorName | ) | const

returns the LE actuator named actuatorName, or a NULL pointer if the named LED actuator has not been found.

std::vector<const LEDActuator*> Sim::Model::ledActuators | ( | const std::string & | groupName = `std::string()` | ) | const

returns a vector containing pointers to all LED actuators of the current model if groupName is empty, and to the LED actuators belonging to the group groupName otherwise

Remarks
  The group names can be retrieved in the documentation.

const Link* Sim::Model::link | ( | const std::string & | linkName | ) | const

returns the link named linkName, or a NULL pointer if the named link has not been found.

std::vector<const Link*> Sim::Model::links | ( |  | ) | const

returns a vector containing pointers to all links of the current model.

const MicrophoneSensor* Sim::Model::microphoneSensor | ( | const std::string & | sensorName | ) | const

returns the microphone sensor named sensorName, or a NULL pointer if the named microphone sensor has not been found.

std::vector<const MicrophoneSensor*> Sim::Model::microphoneSensors | ( |  | ) | const

returns a vector containing pointers to all the microphone sensors of the current model.

const std::string& Sim::Model::name | ( |  | ) | const

gives the robot name. Use this to identify the type of the robot

std::string Sim::Model::prettyName | ( | int | verbosity = `0` | ) | const

gives the displayable, beautiful robot name.

- verbosity from 0 (default) to 2, gives a more precise name of the robot i.e. including its model (verbosity = 1) and its version (verbosity = 2).

const Link* Sim::Model::rootLink | ( |  | ) | const

returns a pointer to the root link of the model, the base link of the Model.

Remarks
  This link defines the global position of the model.

const Sensor* Sim::Model::sensor | ( | const std::string & | sensorName | ) | const

returns the sensor named sensorName, or a NULL pointer if the named sensor has not been found.

std::vector<const Sensor*> Sim::Model::sensors | ( |  | ) | const

returns a vector containing pointers to all sensors of the current model.

const SingleDepthSensor* Sim::Model::singleDepthSensor | ( | const std::string & | sensorName | ) | const

returns the single depth sensor named sensorName, or a NULL pointer if the named single depth sensor has not been found.

std::vector<const SingleDepthSensor*> Sim::Model::singleDepthSensors | ( |  | ) | const

returns a vector containing pointers to all the single depth sensors of the current model.

const SonarSensor* Sim::Model::sonarSensor | ( | const std::string & | sensorName | ) | const

returns the sonar sensor named sensorName, or a NULL pointer if the named sonar sensor has not been found.

std::vector<const SonarSensor*> Sim::Model::sonarSensors | ( |  | ) | const

returns a vector containing pointers to all sonar sensors of the current model.

const TactileSensor* Sim::Model::tactileSensor | ( | const std::string & | sensorName | ) | const

returns the tactile sensor named sensorName, or a NULL pointer if the named tactile sensor has not been found.

std::vector<const TactileSensor*> Sim::Model::tactileSensors | ( |  | ) | const

returns a vector containing pointers to all tactile sensors of the current model.

const TorqueActuator* Sim::Model::torqueActuator | ( | const std::string & | actuatorName | ) | const

returns the torque actuator named actuatorName, or a NULL pointer if the named torque actuator has not been found.

std::vector<const TorqueActuator*> Sim::Model::torqueActuators | ( |  | ) | const

returns a vector containing pointers to all torque actuators of the current model.

const TorqueSensor* Sim::Model::torqueSensor | ( | const std::string & | sensorName | ) | const

returns the torque sensor named sensorName, or a NULL pointer if the named torque sensor has not been found.

std::vector<const TorqueSensor*> Sim::Model::torqueSensors | ( |  | ) | const

returns a vector containing pointers to all torque sensors of the current model.

const WheelTorqueActuator* Sim::Model::wheelTorqueActuator | ( | const std::string & | actuatorName | ) | const

returns the wheel torque actuator named actuatorName, or a NULL pointer if the named wheel torque actuator has not been found.

std::vector<const WheelTorqueActuator*> Sim::Model::wheelTorqueActuators | ( |  | ) | const

returns a vector containing pointers to all wheel torque actuators of the current model.

const WheelVelocityActuator* Sim::Model::wheelVelocityActuator | ( | const std::string & | actuatorName | ) | const

returns the wheel velocity actuator named actuatorName, or a NULL pointer if the named wheel velocity actuator has not been found.

std::vector<const WheelVelocityActuator*> Sim::Model::wheelVelocityActuators | ( |  | ) | const

returns a vector containing pointers to all wheel velocity actuators of the current model.

const WheelVelocitySensor* Sim::Model::wheelVelocitySensor | ( | const std::string & | sensorName | ) | const

returns the wheel velocity sensor named sensorName, or a NULL pointer if the named wheel velocity sensor has not been found.

std::vector<const WheelVelocitySensor*> Sim::Model::wheelVelocitySensors | ( |  | ) | const

returns a vector containing pointers to all wheel velocity sensors of the current model.

## Member Data Documentation

class ModelImpl* Sim::Model::a_impl

private implementation.

Definition at line 340 of file alrobotmodel.h.

The documentation for this class was generated from the following file:

- /home/opennao/work/release-2.8/agility/alrobotmodel/libalrobotmodel/alrobotmodel/alrobotmodel.h